define fn options_init_options (title$,array_with_prompts$,array_with_values$,selkeys$)
rem makes an options window with editable options
rem this presupposes that the colours have been set
rem this prosupposes that a variable caleld "opts_sprite" exists
rem this presupposes that the variblaes defining the item types and event codes have been set
rem this presupposes that this entire options window WIL FIT into the main
rem outline. YOU must make sure of that.
rem
rem parameters:
rem the title of the window
rem the first 2 dimensional string array contains the prompts
rem the second 2 dimensional array contains the current values
rem the third array contains the min and max values an item may have if it is
rem a number - set both to -111 if not applicable
rem
rem returns the wdw definition, or -1 if error
local temp1%,temp2%,temp3%,temp4,lp%
local lxs%,lys%,xesp%,inf1y%,nbr_post%,yinf1y%
local wxsize%,wysize%
local opts_iot1,opts_iwt,opts_lot
local longueur_titre%,titre_x%,opts_defn
local oszsiz%(0,0),oszorgs%(0,0),oszjus%(0,0),sk$
local oszblb(1),oszstr$(0),osztyp%(0),opts_lit%
:
rem now make window(s) ---------------------------------
:
  temp1%=len (selkeys$)-1	: rem number of "rows" -1
  if dimn(array_with_values$,1)<> temp1% or dimn(array_with_prompts$,1) <>temp1%
    return -1
  endif
  wxsize%=dimn(array_with_values$,2) + dimn(array_with_prompts$,2)+2
  wxsize%=wxsize%*6  +20	: rem sizes for strings + spacing
:
  lxs%=24:lys%=12		: rem tailles x et y pour postes standard
  inf1y%=lys%+4 		: rem posi. y de la fen. d'inf. intrieure
  xesp%=lxs%+2
  nbr_post%=1			: rem esc and ok
:
  wysize%=inf1y%+4+(temp1%+1)*12+8
:
  restore
:
  longueur_titre%=len(title$)*6  : rem title object size
  temp2%=longueur_titre% + xesp%*nbr_post%*2 + 8 + 36
  if temp2%>wxsize% : wxsize%= temp2% +20
  titre_x%=(wxsize%-longueur_titre%)/2	 : rem and x position
:
: rem  loose menu items. here there a 2 standard ones (ok, esc) + 1 per value
  yinf1y%=inf1y%+4
:
  opts_lit%=temp1%+2:dim opts_lfl%(opts_lit%) :
:
  temp2%= dimn(array_with_values$,2)
  if temp2%<3:temp2%=3
  dim oszstr$(opts_lit%,temp2%) : rem strings at least 3 chars wide for "esc".
  dim oszblb(opts_lit%)
  dim oszjus%(opts_lit%,1)
  dim oszorg%(opts_lit%,1)
  dim osztyp%(opts_lit%)
  dim oszsiz%(opts_lit%,1)
  sk$=cancel$&"O"
:
  oszstr$(0)="ESC"
  oszsiz%(0,0)=lxs%
  oszsiz%(0,1)=lys%
  oszorg%(0,0)=4
  oszorg%(0,1)=2
  osztyp%(0)=0+retr
:
  oszstr$(1)="OK"
  oszsiz%(1,0)=lxs%
  oszsiz%(1,1)=lys%
  oszorg%(1,0)=wxsize%-2-xesp%
  oszorg%(1,1)= 2
  osztyp%(1)=0+retr
:
  temp2%=dimn(array_with_values$,2)*6+2 : rem xsize
  temp3%=dimn(array_with_prompts$,2)*6+10 : rem x offset
:
  for lp%=2 to temp1%+2
    oszstr$(lp%)=array_with_values$(lp%-2)
    oszsiz%(lp%,0)=temp2%
    oszsiz%(lp%,1)=lys%
    oszorg%(lp%,0)=temp3%
    oszorg%(lp%,1)=yinf1y% - 2*lys% + lp%*lys%
    oszjus%(lp%,0)=1		      : rem justif left
    osztyp%(lp%)=retr
    sk$=sk$&selkeys$(lp%-1)
  end for lp%
  opts_lot=mk_lil(std_iattr,oszsiz%,oszorg%,oszjus%,sk$,osztyp%,oszstr$,oszblb,oszblb,oszblb)
:
  rem now the info objects
:
  rem window title
  opts_iot1=rd_iot(0)
    data longueur_titre%,10,4,int((lys%-10)/2),text,sp.titlefg,0,0,title$
  rem lm labels
  dim oszstr$(temp1%,dimn(array_with_prompts$,2)) : rem strings
  dim oszblb(temp1%)		: rem mis-use this for imod, actually
  dim oszorg%(temp1%,1)
  dim osztyp%(temp1%)
  dim oszsiz%(temp1%,1)
  temp3%=temp3%-8
  temp4=sp.infwinfg*65536	: rem colour of info items
  for lp%=0 to temp1%
    oszstr$(lp%)=array_with_prompts$(lp%)
    oszsiz%(lp%,0)=temp3%
    oszsiz%(lp%,1)=lys%
    oszorg%(lp%,0)=2
    oszorg%(lp%,1)=4 + lp%*12
    oszblb(lp%)=temp4
  end for lp%
  opts_iot2=mk_iol(oszsiz%,oszorg%,oszblb,osztyp%,oszstr$,oszblb,oszblb,oszblb)
:
  remark now the info wdws
:
  opts_iwt=rd_iwt(2)			: remark there are 3
:
remark first the title bar
:
    data wxsize%-8-(2*nbr_post%*xesp%),lys%+3,xesp%*nbr_post%+4,0	  : remark x,y sizes & origs
    data 0,0,sp.infwinbd,sp.titlebg	: remark shadow, border size & col,paper col
    data 0				: remark object pointer (none)
:
remark now wdw containing title itself
:
    data longueur_titre%+8,lys%+1,titre_x%-4,2
    data 0,0,sp.infwindbd,sp.infwinbg
    data opts_iot1			: remark one object
:
remark inner border
:
    data wxsize%-8,wysize%-inf1y%-2,4,inf1y%
    data 0,1,sp.infwinbd,sp.infwinbg
    data opts_iot2
:
: rem  la dfinition de la fentre
:
  opts_defn=rd_wdef
    data 2,1,sp.winbd,sp.winbg: rem ombre, larg. & coul. bord., coul. papier
    data wxsize%,wysize%,wxsize% div 2,wysize% div 2 : rem taille x,y et position pointeur
    data main_sprite,opts_lot,opts_iwt,0
:
  return opts_defn
end define options_init_options
:
def proc options_get_options(array_with_values$,opts_defn,minarr,maxarr,edit_typ%,autofield%)
rem autofield% = the field that should immediately be proposed for editing+1
rem (i.e. 1 = field 0)
rem if there is only one field (dimn (array_withvalues$,1)=0), this will
rem edit the value directly and leave immeditaly after the value was entered
rem edit_typ%= type of edit : 1 =ename, 0=rname
rem
local lil_fl%(0),temp1%,lp%,item%,swnum%,event%,xrel%,yrel%
local chan%,a$,arr$(0),arr1(0),arr2(0),lp2%
  chan%=-1
  temp1%=dimn(array_with_values$,1)
  dim arr$(temp1%,dimn(array_with_values$,2)) : rem temp array if user presses esc
  dim arr1(temp1%)
  if dimn(minarr,1)<>temp1%
    for lp%=0 to temp1%:arr1(lp%)=-111
  else
    for lp%=0 to temp1%:arr1(lp%)=minarr(lp%)
  endif
  dim arr2(temp1%)
  if dimn(maxarr,1)<>temp1%
    for lp%=0 to temp1%:arr2(lp%)=-111
  else
    for lp%=0 to temp1%:arr2(lp%)=maxarr(lp%)
  endif
  for lp%=0 to temp1%:arr$(lp%)=array_with_values$(lp%)
  temp1%=temp1%+2
  dim lil_fl%(temp1%)
  rem chan%=fop_new("con")
  dr_puld opts_defn,-1,-1,lil_fl%
  if temp1%=2 and autofield%=1
     chan%=fop_new("con")
     item%=2
     a$=array_with_values$(0)
     rep lp2%
	 a$=options_get_one_option$(chan%,item%,opts_defn,a$,edit_typ%)
	 if options_value_checks_out_ok%(a$,item%-2,arr1,arr2)
	    arr$(item%-2)=a$
	    exit lp2%
	 endif
     end rep lp2%
     array_with_values$(0)=a$
     close#chan%
     dr_unst opts_defn
     return
  endif
  repeat lp%
    if autofield%
      item%=autofield%+1		: rem field proposed for editing
      autofield%=0
    else
      rd_ptr opts_defn,item%,swnum%,event%,xrel%,yrel%,lil_fl%
    endif
    rem print#chan%,item%
    select on item%
	=0  : exit lp%		: rem quit via esc
	=1  : for lp2%=0 to temp1%-2:array_with_values$(lp2%)=arr$(lp2%)
	      exit lp%		: rem quit via ok, copy new values into old ones
	=2 to temp1%
	   if chan%=-1:chan%=fop_new("con")
	   a$=	arr$(item%-2)
	   rep lp2%
	     a$=options_get_one_option$(chan%,item%,opts_defn,a$,edit_typ%)
	     if options_value_checks_out_ok%(a$,item%-2,arr1,arr2)
		arr$(item%-2)=a$
		exit lp2%
	     endif
	   end rep lp2%
    end select
  end repeat lp%
  if chan%>0:close#chan%
  dr_unst opts_defn
end def options_get_options
:
def fn options_get_one_option$(chan%,it_nbr%,defn,proposal$,edit_typ%)
rem get one option from the options window, by editing a loose menu item content string
rem chan%= channel to use
rem it_nbr%=the item number to edit
rem defn = working defn
rem proposal = proposed string, may be ""
rem edit_typ%= type of edit : 1 =ename, 0=rname
local a$
  dr_lwdf#chan%,defn,it_nbr%
  wm_paper#chan%,sp.litemavabg
  wm_ink#chan%,sp.litemavafg
  cls#chan%
  if edit_typ%
    a$=ename$(#chan%,proposal$)
  else
    a$=rname$(#chan%,proposal$)
  endif
  ch_item defn,-1,it_nbr%,-1,"",a$
  return a$
end def options_get_one_option$
:
def fn options_value_checks_out_ok% (a$ ,item%,min_arr,max_arr)
local lp%,t
  if min_arr(item%)=-111 and max_arr(item%)=-111
    return 1
  endif
  rem if we get here, this MUST be an int
  if a$="":return 0
  for lp%=1 to len (a$)
    t = a$(lp%) instr "0123456789" : rem primitive integer check
    if t=0:return 0
  end for lp%
  t=a$
  if t< min_arr(item%) or t > max_arr(item%) : return 0
  return 1
end def options_value_checks_out_ok%
:
