def proc mk_main_app (subwinarray$)
rem This makes a standard menu appsub with standard global variables.
rem It presumes that the followng vars have been set:
rem  * rows% holds the number of rows to be seen in the appsub window when there
rem    are no scroll arrows (if there are, 1 less row will be seen)
rem  * app_y_orig% = y origin of appsub within the main wdw
rem  * xsize% =window (NOT subwindow) x size
rem  * menu_selkeys$ holds the selkeys to exclude (sting with upper cased skeys)
rem  * app_addr is the address of the appsub winow, is 0 on first call
rem  * appw_sections% holds the nbr of sections to show
rem  * main_cty% (DIMed here) is the  control sections array
rem  * main_mfl% (DIMed here) is the menu items flag array
rem
rem This uses and sets the global vars app_addr, main_cty%, main_mfl%
rem
rem Params:
rem  * subwinarry$ holds the data (2 dimensional string array)
rem
local temp%,att_phys%(3)
  dim main_cty%(0):dim main_mfl%(0,0)
  temp%=appw_sections%			: rem temp% is changed by the call to fen_app
  att_phys%(0)=xsize%-16		: rem xsize according to wdw size
  att_phys%(1)=rows%			: rem ysize = number of rows
  att_phys%(2)=4			: rem x origin
  att_phys%(3)=app_y_orig%		: rem y origin
  app_addr=make_standard_app_sub(app_addr,subwinarray$,temp%,1,att_phys%,menu_selkeys$&" ")
  if app_addr
      dim main_cty%(appw_sections%,2)	: rem control defn
      main_cty%(0,0)=1			: rem at tart show 1 section
      if temp%>rows%
	main_cty%(1,2)=rows%		: rem nbr of rows to show
      else
	main_cty%(1,2)=temp%
      endif
      main_cty%(1,2)=rows%
      if appw_sections%=2:main_cty%(2,2)=2
      if temp%
	 dim main_mfl%(temp%-1,0)	: rem flag array
      else
	 poke_w app_addr,peek_w(app_addr)+8
      end if
      scroll_arrows rows%,temp%,app_addr,main_cty%
  end if
end define mk_main_app
:
